--DYNAMIC FILE INCLUDER for EUPHORIA v2.1b
--by Liquid-Nitrogen 1999.
--This program is Free-Ware.
--If you find it useful, or have an idea/improvement please let me know.
--DISCLAIMER:   I am in no way responsable for any effects caused by the
--              use/misuse of this program.

--What to do:
--===========
--In your main program: declare a global constant called DYNAMIC_INCLUDE_FILES
--it must be a sequence containing file names, ie:
--                                      {"inc1.e","inc2.e","inc3.e".....}
--after the constant declaration add the line:
--                                      include dynaminc.e

--If the constant was not declared before including dynaminc.e then your
--program will crash.

--That's all there is to it! Now you can have access to all the routines and
--variables of the files you specified, just as if you had included them
--normaly.

--The program has some mild error checking, just to make sure the sequence
--of include files is formed correctly. It's up to you to make sure the
--files named are valid and existing include files.

--NOTE: There is currently no way to use this program if you plan on binding
--      your euphoria program I'm sure it'd be easy for Rob Craig to change
--      this so that you can specify an include file should not be bound to
--      the program, but left seperate. Then this program can be changed
--      the following:
--              no_bind_include poiuytre.wqz
--      And now we can use this program in a bound euphoria program.
--      This would make an exelent tool for creating a scripting language.
--      You could even dynamicly *CREATE* include files, include them using
--      this program and then delete them again.

--      This method could be also used as a poor work around for the following
--      pseudo-code fragment:
--          if platform = WIN32 then
--              include win_gfx.e
--          else
--              include dos_gfx.e
--          end if

--      you can say:
--          if platform = WIN32 then
--              DYNAMIC_INCLUDE_FILES = {"win_gfx.e"}
--          else
--              DYNAMIC_INCLUDE_FILES = {"dos_gfx.e"}
--          end if
--          include dynaminc.e

--NOTE2: There is currently no way to use multiple inculdes of dynaminc.e.
--       You can only include dynaminc.e once. But i'm sure that can be
--       worked around!

--NOTE3: DYNAMIC_INCLUDE_FILES doesn't need to be a constant, it can be a
--       global sequence, this allows for you to build up your list of
--       files to include, allowing the conditional inclusion as shown above.
--       But it must be global, otherwise the program can't access it.


--That's all. Have fun.
--      Mark / Liquid-Notrogen Software.

if atom(DYNAMIC_INCLUDE_FILES) then
    puts(1,"ERROR: Constant DYNAMIC_INCLUDE_FILES Must be a sequence\nof file names.\n\n")
    abort(1)
end if
for i = 1 to length(DYNAMIC_INCLUDE_FILES) do
    if atom(DYNAMIC_INCLUDE_FILES[i]) then
	printf(1,"ERROR: Constant DYNAMIC_INCLUDE_FILES conatins an atom as element %d\nwhere there should be a sequence.\n\n",i)
	abort(1)
    end if
    for j = 1 to length(DYNAMIC_INCLUDE_FILES[i]) do
	if sequence(DYNAMIC_INCLUDE_FILES[i][j]) then
	    printf(1,"ERROR: Found a sequence in file number %d of DYNAMIC_INCLUDE_FILES.\n\n",i)
	    abort(1)
	end if
    end for
end for

integer fn
fn = open("poiuytre.wqz","w")
for i = 1 to length(DYNAMIC_INCLUDE_FILES) do
    printf(fn,"include %s\n\r",{DYNAMIC_INCLUDE_FILES[i]})
end for
close(fn)

include poiuytre.wqz

system("del poiuytre.wqz",0)


--How it works:
--=============
--A file "poiutre.wqz" is created.
--This file contains euphoria code to include the desired files.
--"poiuytre.wqz" is included, thus causing the desired files to also be included
--"poiuytre.wqz" is then deleted.
--===============================
