-- Program Manager Window
constant ProgMan =  
    create( Window, "Program Manager", 0, -5, -20, xPixels+10, 35, 0 )

constant mnuProg = create( Menu, "Start", ProgMan, 0, 0, 0, 0, 0 )

-- Add Program Window
constant frmAdd = 
    create( Window, "Add Program", 0, Default, Default, 350, 150, 0 )
     
constant lblName = create( LText, "Name:", frmAdd, 10, 10, 20, 20, 0 )

constant txtName = create( EditText, "", frmAdd, 125, 10, 200, 20, 0 )

constant lblFile = create( LText, ".ex File:", frmAdd, 10, 35, 20, 20, 0 )

constant txtFile = create( EditText, "", frmAdd, 125, 35, 200, 20, 0 )

constant lblProc = create( LText, "StartUp Procedure:", frmAdd, 10, 65, 20, 20, 0 )

constant txtProc = create( EditText, "", frmAdd, 125, 60, 200, 20, 0 )

setText(txtProc, "Main")

constant AddButton = 
    create( PushButton, "OK", frmAdd, 50, 100, 125, 20, 0 )

constant CancelButton = 
    create( PushButton, "Cancel", frmAdd, 200, 100, 125, 20, 0 )
            

-- Program Manager Window Events
procedure mnuPrograms_Click(sequence Name)
    new( Name, "Program" & (length(objects) + 1), {} )    
end procedure                             

procedure mnuAdd_Click(sequence Name)
    openModal( frmAdd )    
end procedure                        

RegisterEvent( "mnuAdd", "Click", routine_id("mnuAdd_Click") )

procedure mnuExit_Click(sequence Name)
    integer res
    
    res = message_box("Exit Program Manager?", "Program Manager", MB_ICONQUESTION+MB_YESNO)

    if res = IDYES then
        closeWindow( ProgMan )    
    end if                    
    
end procedure                         

RegisterEvent( "mnuExit", "Click", routine_id("mnuExit_Click") )

-- Add Program Events
procedure onClick_AddButton()
    integer res
    sequence sName, sFile, sProc, ext
    
    sName = getText(txtName)
    sFile = getText(txtFile)
    sProc = getText(txtProc)
    
    if length(sName) > 0 and length(sFile) > 0 and length(sProc) > 0 then
        ext = sFile[length(sFile)-1..length(sFile)]
        if equal(ext, "ex") = 1 then
            res = message_box("Add " & sName & " to the Start Menu?", 
                "Program Manager", MB_ICONQUESTION+MB_YESNO)
            if res = IDYES then
                MakeOxeFile(sName, sFile, sProc)
                DYNAMIC_INCLUDE_FILES = append(DYNAMIC_INCLUDE_FILES, sFile[1..length(sFile)-2] & "oxe")
                saveProgramList()
                res = message_box("You must restart Program Manager for this program to work." & 13 & 10 &
                    "Exit now?", "Program Manager", MB_ICONQUESTION+MB_YESNO)    
                if res = IDYES then
                    res = graphics_mode(-1)
                    clear_screen()
                    puts(1, "Type ex ProgMan to start Program Manager again.")
                    abort(1)
                end if           
                closeWindow( frmAdd )
            end if
        else
            res = message_box("Only .ex files can be added to the program list.",
                "Program Manager",
                MB_ICONEXCLAMATION+MB_OK)
        end if           
    else
        res = message_box("You need to fill in all of the text boxes.", 
            "Program Manager", MB_ICONEXCLAMATION+MB_OK)
    end if              
    
end procedure                

onClick[AddButton] = routine_id( "onClick_AddButton" )

procedure onClick_CancelButton()
    closeWindow( frmAdd )
end procedure            

onClick[CancelButton] = routine_id( "onClick_CancelButton" )

procedure MakeProgramList()
    new( "MenuItem", "mnuAdd", {"Add Program", mnuProg} )
    new( "MenuItem", "mnuSep0", {"-", mnuProg} )
    Programs = sort(Programs)
    for a = 1 to length(Programs) do
        new( "MenuItem", Programs[a], {Programs[a], mnuProg} )
        RegisterEvent( Programs[a], "Click", routine_id("mnuPrograms_Click"))            
    end for
    if length(Programs) = 0 then
        new( "MenuItem", "mnuNoPrograms", {"(empty)", mnuProg} )
        setEnable( getProp( "mnuNoPrograms", "ID" ), 0 )    
    end if
    new( "MenuItem", "mnuSep1", {"-", mnuProg} )
    new( "MenuItem", "mnuExit", {"Exit", mnuProg} )
end procedure              

-- hand control over to Windows
global procedure StartProgMan()
    MakeProgramList()
    WinMain( ProgMan )
end procedure


