-- scan.e
-- convert scan codes to ascii codes

global constant     

    -- Toggle Keys 
    CTRL        = -1,
    LEFT_SHIFT  = -2,
    RIGHT_SHIFT = -3,
    ALT         = -4,
    CAPS_LOCK   = -5,
    NUM_LOCK    = -6,
    SCROLL_LOCK = -7,
    
    
    BACKSPACE = 8, 
    TAB = 9, 
    ENTER = 13, 
    ESC = 27,
    SHIFT_TAB = 271,

    ALT_A = 286, 
    ALT_B = 304, 
    ALT_C = 302,
    ALT_D = 288, 
    ALT_E = 274, 
    ALT_F = 289,
    ALT_G = 290, 
    ALT_H = 291, 
    ALT_I = 279,
    ALT_J = 292, 
    ALT_K = 293, 
    ALT_L = 294,
    ALT_M = 306, 
    ALT_N = 305, 
    ALT_O = 280,
    ALT_P = 281, 
    ALT_Q = 272, 
    ALT_R = 275,
    ALT_S = 287, 
    ALT_T = 276, 
    ALT_U = 278,
    ALT_V = 303, 
    ALT_W = 273, 
    ALT_X = 301,
    ALT_Y = 277, 
    ALT_Z = 300, 
    ALT_1 = 376,
    ALT_2 = 377, 
    ALT_3 = 378, 
    ALT_4 = 379,
    ALT_5 = 380, 
    ALT_6 = 381, 
    ALT_7 = 382,
    ALT_8 = 383, 
    ALT_9 = 384, 
    ALT_0 = 385,

    CTRL_A = 01, 
    CTRL_B = 02, 
    CTRL_C = 03,
    CTRL_D = 04, 
    CTRL_E = 05, 
    CTRL_F = 06,
    CTRL_G = 07, 
    CTRL_H = 08, 
    CTRL_I = 09,
    CTRL_J = 10, 
    CTRL_K = 11, 
    CTRL_L = 12,
    CTRL_M = 13, 
    CTRL_N = 14, 
    CTRL_O = 15,
    CTRL_P = 16, 
    CTRL_Q = 17, 
    CTRL_R = 18,        
    CTRL_S = 19, 
    CTRL_T = 20, 
    CTRL_U = 21,
    CTRL_V = 22, 
    CTRL_W = 23, 
    CTRL_X = 24,
    CTRL_Y = 25, 
    CTRL_Z = 26, 

    F1 = 315, 
    F2 = 316, 
    F3 = 317, 
    F4 = 318, 
    F5 = 319,    
    F6 = 320, 
    F7 = 321, 
    F8 = 322, 
    F9 = 323, 
    F10 = 324,
    F11 = 389, 
    F12 = 390,

    HOME = 327, 
    UP = 328, 
    PAGE_UP = 329, 
    LEFT = 331,
    RIGHT = 333, 
    END = 335, 
    DOWN = 336, 
    PAGE_DOWN = 337, 
    INSERT = 338, 
    DELETE = 339, 

    CTRL_LEFT = 371, 
    CTRL_RIGHT = 372, 
    CTRL_END = 373,
    CTRL_HOME = 375, 
    CTRL_PAGE_UP = 388, 
    CTRL_PAGE_DOWN = 374,
    CTRL_UP = 397, 
    CTRL_DOWN = 401, 
    CTRL_INSERT = 402,
    CTRL_TAB = 404, 
    CTRL_ENTER = 10



-- unshifted keys
sequence unshifted 
unshifted = repeat( 0, 256 )
unshifted[1]    = ESC
unshifted[2]    = '!'
unshifted[3]    = '@'
unshifted[4]    = '#'
unshifted[5]    = '$'
unshifted[6]    = '%'
unshifted[7]    = '^'
unshifted[8]    = '&'
unshifted[9]    = '*'
unshifted[10]   = '('
unshifted[11]   = ')'
unshifted[12]   = '_'
unshifted[13]   = '+'
unshifted[14]   = BACKSPACE
unshifted[15]   = TAB
unshifted[16]   = 'q'
unshifted[17]   = 'w'
unshifted[18]   = 'e'
unshifted[19]   = 'r'
unshifted[20]   = 't'
unshifted[21]   = 'y'
unshifted[22]   = 'u'
unshifted[23]   = 'i'
unshifted[24]   = 'o' 
unshifted[25]   = 'p'
unshifted[26]   = '['
unshifted[27]   = ']'
unshifted[28]   = ENTER
unshifted[29]   = CTRL
unshifted[30]   = 'a'
unshifted[31]   = 's'
unshifted[32]   = 'd'
unshifted[33]   = 'f'
unshifted[34]   = 'g' 
unshifted[35]   = 'h'
unshifted[36]   = 'j'
unshifted[37]   = 'k'
unshifted[38]   = 'l'
unshifted[39]   = ';'
unshifted[40]   = '\''
unshifted[41]   = '`'
unshifted[42]   = LEFT_SHIFT
unshifted[43]   = '\\'
unshifted[44]   = 'z' 
unshifted[45]   = 'x'
unshifted[46]   = 'c'
unshifted[47]   = 'v'
unshifted[48]   = 'b'
unshifted[49]   = 'n'
unshifted[50]   = 'm'
unshifted[51]   = ','
unshifted[52]   = '.'
unshifted[53]   = '/'
unshifted[54]   = RIGHT_SHIFT
unshifted[55]   = 0 --SysRq
unshifted[56]   = ALT
unshifted[57]   = ' '
unshifted[58]   = CAPS_LOCK
unshifted[59]   = F1
unshifted[60]   = F2
unshifted[61]   = F3
unshifted[62]   = F4
unshifted[63]   = F5
unshifted[64]   = F6
unshifted[65]   = F7
unshifted[66]   = F8
unshifted[67]   = F9
unshifted[68]   = F10
unshifted[69]   = NUM_LOCK
unshifted[70]   = SCROLL_LOCK
unshifted[71]   = HOME
unshifted[72]   = UP
unshifted[73]   = PAGE_UP
unshifted[74]   = '-' --GrayMinus
unshifted[75]   = '4' --Left
unshifted[76]   = '5' --Center
unshifted[77]   = '6' --Right
unshifted[78]   = '+' --GrayPlus
unshifted[79]   = '1' --End
unshifted[80]   = '2' --Down
unshifted[81]   = '3' --PgDn
unshifted[82]   = '0' --Ins
unshifted[83]   = '.' --Del
unshifted[133]  = F11
unshifted[134]  = F12

-- shifted keys
sequence shifted
shifted = repeat( 0, 256 )
shifted[1]    = ESC
shifted[2]    = '1'
shifted[3]    = '2'
shifted[4]    = '3'
shifted[5]    = '4'
shifted[6]    = '5'
shifted[7]    = '6'
shifted[8]    = '7'
shifted[9]    = '8'
shifted[10]   = '9'
shifted[11]   = '0'
shifted[12]   = '-'
shifted[13]   = '='
shifted[14]   = 0
shifted[15]   = SHIFT_TAB
shifted[16]   = 'Q'
shifted[17]   = 'W'
shifted[18]   = 'E'
shifted[19]   = 'R'
shifted[20]   = 'T'
shifted[21]   = 'Y'
shifted[22]   = 'U'
shifted[23]   = 'I'
shifted[24]   = 'O' 
shifted[25]   = 'P'
shifted[26]   = '{'
shifted[27]   = '}'
shifted[28]   = 0 --ENTER
shifted[29]   = 0 --Ctrl
shifted[30]   = 'A'
shifted[31]   = 'S'
shifted[32]   = 'D'
shifted[33]   = 'F'
shifted[34]   = 'G' 
shifted[35]   = 'H'
shifted[36]   = 'J'
shifted[37]   = 'K'
shifted[38]   = 'L'
shifted[39]   = ':'
shifted[40]   = '\"'
shifted[41]   = '~'
shifted[42]   = 0
shifted[43]   = '|'
shifted[44]   = 'Z' 
shifted[45]   = 'X'
shifted[46]   = 'C'
shifted[47]   = 'V'
shifted[48]   = 'B'
shifted[49]   = 'N'
shifted[50]   = 'M'
shifted[51]   = '<'
shifted[52]   = '>'
shifted[53]   = '?'

global function scanToAscii( sequence scanKeys )
    integer shift, key
    sequence translated
    
    translated = {}
    if find( 42, scanKeys )
    or find( 54, scanKeys ) then
        shift = 1
    else
        shift = 0                
    end if
    
    for i = 1 to length( scanKeys ) do
        key = scanKeys[i]
        if key < 256 then
            if shift and shifted[key] then
                key = shifted[key]
            else
                key = unshifted[key]
            end if
            translated = append( translated, key )
        end if
    end for
    
    return translated
    
end function


-- In Euphoria 2.1 this file (unless modified) is FREE - 0 statements.
with 53418515 -- delete this statement if it causes an error

